/*
 *   Copyright (C) 2001  Andrea Gini
 *
 *   Require JDK 1.3
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 *   Send questions or suggestions to ginian@tiscalinet.it
 *
 */
import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class BadTextEditor extends JFrame implements ActionListener {

  private JTextComponent editor;
  private JFileChooser fileChooser;

  private JMenuItem OpenMenuItem;
  private JMenuItem SaveMenuItem;
  private JMenuItem CutMenuItem;
  private JMenuItem CopyMenuItem;
  private JMenuItem PasteMenuItem; 
    
  private JButton OpenButton; 
  private JButton SaveButton;
  private JButton CutButton;
  private JButton CopyButton;
  private JButton PasteButton;

  public BadTextEditor() {
    setTitle("TextEditor");
    setSize(300,300);
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    editor = new JTextArea();
    fileChooser = new JFileChooser();

    OpenMenuItem = new JMenuItem("Open",new ImageIcon("Open24.gif"));
    SaveMenuItem = new JMenuItem("Save",new ImageIcon("Save24.gif"));
    CutMenuItem = new JMenuItem("Cut",new ImageIcon("Cut24.gif"));
    CopyMenuItem = new JMenuItem("Copy",new ImageIcon("Copy24.gif"));
    PasteMenuItem = new JMenuItem("Paste",new ImageIcon("Paste24.gif"));

    OpenButton = new JButton(new ImageIcon("Open24.gif"));
    SaveButton = new JButton(new ImageIcon("Save24.gif"));
    CutButton = new JButton(new ImageIcon("Cut24.gif"));
    CopyButton = new JButton(new ImageIcon("Copy24.gif"));
    PasteButton = new JButton(new ImageIcon("Paste24.gif"));
    
    JMenu menu = new JMenu("Menu");
      menu.add(OpenMenuItem);
      menu.add(SaveMenuItem);
      menu.addSeparator();
      menu.add(CutMenuItem);
      menu.add(CopyMenuItem);
      menu.add(PasteMenuItem);
    JMenuBar menuBar = new JMenuBar();
    menuBar.add(menu);

    JToolBar toolbar = new JToolBar();
    toolbar.add(OpenButton);
    toolbar.add(SaveButton);
    toolbar.addSeparator();
    toolbar.add(CutButton);
    toolbar.add(CopyButton);
    toolbar.add(PasteButton);

    OpenMenuItem.addActionListener(this);
    SaveMenuItem.addActionListener(this);
    CutMenuItem.addActionListener(this);
    CopyMenuItem.addActionListener(this);
    PasteMenuItem.addActionListener(this);

    OpenButton.addActionListener(this);
    SaveButton.addActionListener(this);
    CutButton.addActionListener(this);
    CopyButton.addActionListener(this);
    PasteButton.addActionListener(this);

    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(BorderLayout.NORTH,toolbar);
    getContentPane().add(BorderLayout.CENTER,new JScrollPane(editor));
    setJMenuBar(menuBar);
 }
  public void actionPerformed(ActionEvent ae) {
    if(ae.getSource().equals(OpenButton) || ae.getSource().equals(OpenMenuItem)) {
      int response = fileChooser.showOpenDialog(this);
      if(response==JFileChooser.APPROVE_OPTION) {
        try {
          File f = fileChooser.getSelectedFile();
          Reader in = new FileReader(f);
          editor.read(in,null);
        }
        catch(Exception e) {}
      }  
    }
    else if(ae.getSource().equals(SaveButton) || ae.getSource().equals(SaveMenuItem)) {
      int response = fileChooser.showSaveDialog(this);
      if(response==JFileChooser.APPROVE_OPTION) {
        try {
          File f = fileChooser.getSelectedFile();
          Writer out = new FileWriter(f);
          editor.write(out);
        }
        catch(Exception e) {}
      }  
    }
    else if(ae.getSource().equals(CutButton) || ae.getSource().equals(CutMenuItem)) {
      editor.cut();
    }
    else if(ae.getSource().equals(CopyButton) || ae.getSource().equals(CopyMenuItem)) {
      editor.copy();
    }
    else if(ae.getSource().equals(PasteButton) || ae.getSource().equals(PasteMenuItem)) {
      editor.paste();
    }      
  }
  public static void main(String argv[]) {
    BadTextEditor b = new BadTextEditor();
    b.setVisible(true); 
  }
}